/*=========================================================================*/
/*                              CAbout.CPP                                 */
/*                                                                         */
/*                                                                         */
/*                CookieCop 2 Copyright (c) 2000,2002                      */
/*                       Ziff Davis Media, Inc.                            */
/*                        All rights reserved.							   */
/*																		   */
/*                     Programmed by Mark Sweeney                          */
/*                                                                         */
/*=========================================================================*/
#include "stdafx.h"
#include "cookiecop.h"
#include "About.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment( lib, "version.lib" )

/////////////////////////////////////////////////////////////////////////////
// CAbout property page

IMPLEMENT_DYNCREATE(CAbout, CPropertyPage)

CAbout::CAbout() : CPropertyPage(CAbout::IDD)
{
	//{{AFX_DATA_INIT(CAbout)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAbout::~CAbout()
{
}

void CAbout::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAbout)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAbout, CPropertyPage)
	//{{AFX_MSG_MAP(CAbout)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_DEBUGFILE, OnDebugfile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAbout message handlers
void CAbout::InitAboutBox( )
{
    TCHAR szFullPath[256];
    DWORD dwVerHnd;
    DWORD dwVerInfoSize;
	HINSTANCE hInst = AfxGetInstanceHandle( );
	 
    // Get version information from the application
    GetModuleFileName( hInst, szFullPath, sizeof(szFullPath) );
    dwVerInfoSize = GetFileVersionInfoSize( szFullPath, &dwVerHnd );

	if( dwVerInfoSize )
    {
        // If we were able to get the information, process it:
        HANDLE  hMem;
        LPVOID  lpvMem;
        TCHAR   szGetName[256];
        int     cchRoot;
        int     i;

        hMem = GlobalAlloc(GMEM_MOVEABLE, dwVerInfoSize);
        lpvMem = GlobalLock(hMem);
        GetFileVersionInfo(szFullPath, dwVerHnd, dwVerInfoSize, lpvMem);
        lstrcpy(szGetName, _T("\\StringFileInfo\\040904b0\\") );
        cchRoot = lstrlen( szGetName );

        // Walk through the dialog items that we want to replace:
        for( i = 0; i < 3; i++ )
        {
            BOOL  fRet;
            UINT  cchVer = 0;
            LPTSTR lszVer = NULL;
            TCHAR  szResult[256];
			WORD  wID = 0;

			switch( i )
			{
				case 0:
					wID = IDC_COPYRIGHT;
					break;
				case 1:
					wID = IDC_VERSION;
					break;
			}
				
            if( wID )
			{
				GetDlgItemText( wID, szResult, sizeof(szResult));
				lstrcpy( &szGetName[cchRoot], szResult );
				fRet = VerQueryValue( lpvMem, szGetName, (void**)&lszVer, &cchVer );

				if( fRet && cchVer && lszVer )
				{
					// Replace dialog item text with version info
					lstrcpy( szResult, lszVer );
					SetDlgItemText( wID, szResult );
				}
			}
        }
        GlobalUnlock( hMem );
        GlobalFree( hMem );
    }

    return;
}


BOOL CAbout::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	InitAboutBox( );	
	
	#ifndef _DEBUGFILE //~6
	GetDlgItem( IDC_DEBUGFILE )->ShowWindow( SW_HIDE );
	#endif

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CAbout::OnPaint() 
{
	CDialog::OnPaint();	 
}

//Write all data received and transmitted to a debug file -- C:\Debug.txt.
//This is only enabled if _DEBUGFILE has been defined, and will display a
//[x] Debug File option on the About tab.
//This function is not used in v1.2
void CAbout::OnDebugfile() 
{
	#ifdef _DEBUGFILE 
	if( m_theApp->m_DebugFile.m_hFile != -1 )
		m_theApp->m_DebugFile.Close( );
				
	if( IsDlgButtonChecked( IDC_DEBUGFILE ) )
	{
		m_theApp->m_DebugFile.Open("C:\\debug.txt", CFile::modeCreate | CFile::modeWrite  );
		m_theApp->m_bDebugFile = TRUE;
	} else {
		m_theApp->m_bDebugFile = FALSE;
	}
	#endif

}
