/*=========================================================================*/
/*                         BrowserDlg.cpp                                  */
/*                                                                         */
/*                                                                         */
/*                CookieCop 2 Copyright (c) 2000,2002                      */
/*                       Ziff Davis Media, Inc.                            */
/*                        All rights reserved.							   */
/*																		   */
/*                     Programmed by Mark Sweeney                          */
/*                                                                         */
/*=========================================================================*/
#include "stdafx.h"
#include "cookiecop.h"
#include "BrowserDlg.h"
#include "Config.h"
#include "WarningDlgs.h"
#include "DlgPropSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SZ_NOTFOUND "Not installed or unable to locate." 

/////////////////////////////////////////////////////////////////////////////
// CBrowserDlg property page

IMPLEMENT_DYNCREATE(CBrowserDlg, CPropertyPage)

CBrowserDlg::CBrowserDlg() : CPropertyPage(CBrowserDlg::IDD)
{
	//{{AFX_DATA_INIT(CBrowserDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CBrowserDlg::~CBrowserDlg()
{
}

void CBrowserDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowserDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBrowserDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CBrowserDlg)
	ON_BN_CLICKED(IDC_IE_AUTOCONFIG, OnIeAutoconfig)
	ON_BN_CLICKED(IDC_IE_RESTORE, OnIeRestore)
	ON_BN_CLICKED(IDC_NAV_BROWSE, OnNavBrowse)
	ON_BN_CLICKED(IDC_IE_SCANFILES, OnIeScanfiles)
	ON_BN_CLICKED(IDC_NAV_SCANFILES, OnNavScanfiles)
	ON_EN_CHANGE(IDC_NAV_COOKIE_LOCATION, OnChangeNavCookieLocation)
	ON_BN_CLICKED(IDC_IE_BROWSE, OnIeBrowse)
	ON_EN_CHANGE(IDC_IE_COOKIE_LOCATION, OnChangeIeCookieLocation)
	ON_BN_CLICKED(IDC_ENABLE_PROXY, OnDisableProxy)
	ON_BN_CLICKED(IDC_DISABLE_COOKIECOP, OnDisableCookiecop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowserDlg message handlers


void CBrowserDlg::PopulateControls( ) 
{
	char szPath[MAX_PATH];
	char szVersion[MAX_PATH];
	int  nVersionNumbers[4];
	CString sCookieCop_INI;
	BOOL bAutoConfig_IE = FALSE;
	BOOL bAutoRestore_IE = FALSE;
	BOOL bScanFolder_IE = FALSE;
	
	QualifyPathName( &sCookieCop_INI, SZ_COOKIECOP_INI  );

	m_theApp->m_bScanFolder_IE = GetPrivateProfileInt( SZ_APPNAME, SZ_IE_SCAN_COOKIE_FILE, 0, sCookieCop_INI );
	m_theApp->m_bScanFolder_Nav= GetPrivateProfileInt( SZ_APPNAME, SZ_NAV_SCAN_COOKIE_FILE, 0, sCookieCop_INI);	


	//1.1 allow the user to select the folder even if the Netscape.exe info was not found in the registry.  
	GetPrivateProfileString( SZ_APPNAME, SZ_NAV_COOKIE_FILE, "", szPath,sizeof(szPath), sCookieCop_INI );
	m_theApp->m_sCookieFile_Nav = szPath;

	SetDlgItemText( IDC_NAV_COOKIE_LOCATION, m_theApp->m_sCookieFile_Nav );	
	//SetDlgItemText( IDC_NAV_VERSION, szVersion );       //no longer display the version

	
	if( GetBrowsersPaths( "Iexplore.exe", szPath ) )
	{
		bAutoConfig_IE = FALSE;
		bScanFolder_IE = TRUE;
		GetVersionNumber( szPath, szVersion, nVersionNumbers, 4 );
		
		//we can autoconfig IE4
		if( nVersionNumbers[0] == 4 )
			bAutoConfig_IE = TRUE;			
	
		if( bAutoConfig_IE )
			if( ConfigSaved_IE( ) )
				bAutoRestore_IE = TRUE;
		
	} else {
		strcpy( szVersion, SZ_NOTFOUND );		
	}

	//SetDlgItemText( IDC_IE_VERSION, szVersion );  //no longer display the version

	//Location of Cookie folder
	LPITEMIDLIST pidl;   
	LPMALLOC pMalloc;
	char szCookieDir[MAX_PATH];

	szCookieDir[0] = 0;
	if( SUCCEEDED( SHGetMalloc( &pMalloc ) ) ) 
	{
		if( SUCCEEDED( SHGetSpecialFolderLocation( NULL, CSIDL_COOKIES, &pidl ) ) )
			SHGetPathFromIDList( pidl, szCookieDir );

		pMalloc->Free( pidl );
		pMalloc->Release( );
	} 
	
	//Note: The SHGetSpecialFolderLocation( NULL, CSIDL_COOKIES, &pidl );
	//function will only work with version 4.70 or higher of the shell,  
	//The shell is only updated if the user has installed IE 4.
	//IE 5.x does not update the shell.  
	if( szCookieDir[0] )
	{
		GetDlgItem(IDC_IE_COOKIE_LOCATION)->EnableWindow( FALSE );
		GetDlgItem(IDC_IE_BROWSE)->EnableWindow( FALSE );
		m_theApp->m_sCookieFile_IE = szCookieDir;
	
	} else {

		GetPrivateProfileString( SZ_APPNAME, SZ_IE_COOKIE_FOLDER, "", szCookieDir, sizeof(szCookieDir), sCookieCop_INI );
		m_theApp->m_sCookieFile_IE = szCookieDir;
	}
	
	int iLen = m_theApp->m_sCookieFile_IE.GetLength( );
	if( iLen > 1 )
	{
		char ch = m_theApp->m_sCookieFile_IE.GetAt(--iLen);
		if( ch == '\\' || ch == '/' )
			m_theApp->m_sCookieFile_IE = m_theApp->m_sCookieFile_IE.Left( iLen );
	}
	
	//enable auto config
	if( bAutoConfig_IE )
		if( ConfigRestored_IE( ) == 0)
			bAutoConfig_IE = FALSE;
	
	//enable auto restore
	if( bAutoRestore_IE )
		if( ConfigRestored_IE( ) )
			bAutoRestore_IE = FALSE;

	//enable - disable buttons
    CheckDlgButton(IDC_IE_SCANFILES, m_theApp->m_bScanFolder_IE );
	CheckDlgButton(IDC_NAV_SCANFILES, m_theApp->m_bScanFolder_Nav ); 

	GetDlgItem( IDC_IE_AUTOCONFIG)->EnableWindow( bAutoConfig_IE );
	GetDlgItem( IDC_IE_RESTORE )->EnableWindow( bAutoRestore_IE );
	
	SetDlgItemText( IDC_NAV_COOKIE_LOCATION, m_theApp->m_sCookieFile_Nav );	
	SetDlgItemText( IDC_IE_COOKIE_LOCATION, m_theApp->m_sCookieFile_IE );
    SetProxyOptions( ) ;
    
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CBrowserDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	PopulateControls( );
	SetModified( FALSE );							  
    return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnIeAutoconfig() 
{
	AutoConfigureIE( );
	PopulateControls( );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnIeRestore() 
{
	if( ShowWarning( IDS_RESTORE_IE, IDYES ) == IDYES )
	{
		if( RestoreConfiguration_IE( ) )
			ShowError( IDS_RESTORE_OK, MB_OK | MB_ICONINFORMATION );
		else
			ShowError( IDS_RESTORE_ERROR, MB_OK | MB_ICONHAND );
	}
	PopulateControls( );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnIeBrowse() 
{
    LPMALLOC pMalloc;
    /* Gets the Shell's default allocator */
    if (::SHGetMalloc(&pMalloc) == NOERROR)
    {
        BROWSEINFO bi;
        char szDir[MAX_PATH];
        LPITEMIDLIST pidl;
        
        bi.hwndOwner = GetSafeHwnd();
        bi.pidlRoot = NULL;
        bi.pszDisplayName = szDir;
        bi.lpszTitle = _T("Internet Explorer Cookie Folder");
        bi.ulFlags = BIF_RETURNFSANCESTORS | BIF_RETURNONLYFSDIRS;
        bi.lpfn = NULL;
        bi.lParam = 0;
        
        if ((pidl = ::SHBrowseForFolder(&bi)) != NULL)
        {
            if (::SHGetPathFromIDList(pidl, szDir))
            { 
			    // At this point szDir contains the selected path */.
				m_theApp->m_sCookieFile_IE = szDir;
				SetDlgItemText( IDC_IE_COOKIE_LOCATION, m_theApp->m_sCookieFile_IE );	
				SetModified( TRUE );
            }
            // Free the PIDL allocated by SHBrowseForFolder.
            pMalloc->Free(pidl);
        }
        // Release the shell's allocator.
        pMalloc->Release();
    }
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnNavBrowse() 
{
	CFileDialog dlg(TRUE,
		".TXT",
		m_theApp->m_sCookieFile_Nav, 
		0,
		"Cookies.txt|cookies.txt||",
		this);

	dlg.m_ofn.lpstrTitle = "Netscape Cookie File";
	dlg.m_ofn.Flags |= OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;
	
	if( dlg.DoModal() == IDOK ) 
	{
		m_theApp->m_sCookieFile_Nav = dlg.GetPathName();
		SetDlgItemText( IDC_NAV_COOKIE_LOCATION, m_theApp->m_sCookieFile_Nav );	
		SetModified( TRUE );
	}
	
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CBrowserDlg::OnApply() 
{
	char szBuf[30];
	CString sCookieCop_INI;
	QualifyPathName( &sCookieCop_INI, SZ_COOKIECOP_INI  );

	WritePrivateProfileString( SZ_APPNAME, SZ_NAV_COOKIE_FILE, m_theApp->m_sCookieFile_Nav, sCookieCop_INI );
	
	WritePrivateProfileString( SZ_APPNAME, SZ_IE_COOKIE_FOLDER, m_theApp->m_sCookieFile_IE, sCookieCop_INI );

	wsprintf( szBuf, "%u", m_theApp->m_bScanFolder_IE );
	WritePrivateProfileString( SZ_APPNAME, SZ_IE_SCAN_COOKIE_FILE, szBuf, sCookieCop_INI );
		
	wsprintf( szBuf, "%u", m_theApp->m_bScanFolder_Nav );
	WritePrivateProfileString( SZ_APPNAME, SZ_NAV_SCAN_COOKIE_FILE, szBuf, sCookieCop_INI );

	SetModified( FALSE );
	
	return CPropertyPage::OnApply();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnReset() 
{
	PopulateControls();
	CPropertyPage::OnReset();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnIeScanfiles() 
{
	m_theApp->m_bScanFolder_IE = IsDlgButtonChecked( IDC_IE_SCANFILES );
	SetModified( TRUE );							  
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnNavScanfiles() 
{
	m_theApp->m_bScanFolder_Nav = IsDlgButtonChecked( IDC_NAV_SCANFILES );
	SetModified( TRUE );							  
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnChangeNavCookieLocation() 
{
	GetDlgItemText( IDC_NAV_COOKIE_LOCATION, m_theApp->m_sCookieFile_Nav );
	SetModified( TRUE );	

	//check for empty directory	
	if( m_theApp->m_sCookieFile_Nav.IsEmpty( ) )
	{
		m_theApp->m_bScanFolder_Nav = FALSE;
		CheckDlgButton(IDC_NAV_SCANFILES, m_theApp->m_bScanFolder_Nav );
		GetDlgItem( IDC_NAV_SCANFILES )->EnableWindow( FALSE );
	} else {
		GetDlgItem( IDC_NAV_SCANFILES)->EnableWindow( TRUE );
	}
}


/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnChangeIeCookieLocation() 
{
	GetDlgItemText( IDC_IE_COOKIE_LOCATION, m_theApp->m_sCookieFile_IE );
	SetModified( TRUE );	

	//check for empty directory
	if( m_theApp->m_sCookieFile_IE.IsEmpty( ) )
	{
		m_theApp->m_bScanFolder_IE = FALSE;
		CheckDlgButton(IDC_IE_SCANFILES, m_theApp->m_bScanFolder_IE );
		GetDlgItem( IDC_IE_SCANFILES )->EnableWindow( FALSE );
	} else {
		GetDlgItem( IDC_IE_SCANFILES )->EnableWindow( TRUE );
	}
	
}

/////////////////////////////////////////////////////////////////////////////
//called from the tray icon to keep the settings in sync
void CBrowserDlg::SetProxyOptions( )
{
    CheckDlgButton( IDC_ENABLE_PROXY, (m_theApp->m_bDisableProxy == FALSE) ); 
    CheckDlgButton( IDC_DISABLE_COOKIECOP, !m_theApp->m_bDisableCookieCop ); 
    GetDlgItem( IDC_ENABLE_PROXY )->EnableWindow(m_theApp->AllowEnableIEProxy( ) );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnDisableProxy() 
{
    m_theApp->m_bDisableProxy = ( IsDlgButtonChecked( IDC_ENABLE_PROXY ) == FALSE );	
    m_theApp->EnableProxy( !m_theApp->m_bDisableProxy );
    SetModified( TRUE );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CBrowserDlg::OnDisableCookiecop() 
{
    m_theApp->m_bDisableCookieCop = !IsDlgButtonChecked( IDC_DISABLE_COOKIECOP );
    
    //update the systray icon
    m_theApp->m_pDlg->UpdateTrayIcon( );   
    
    SetModified( TRUE );
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CBrowserDlg::OnSetActive() 
{
    BOOL bModified = FALSE;
   
    if( m_hWnd )
    {
        HWND hWnd = ::GetParent( m_hWnd );
        if( hWnd )
            bModified = ::IsWindowEnabled( ::GetDlgItem( hWnd, ID_APPLY_NOW ) );
    }    

    PopulateControls( );
    SetModified( bModified );
	return CPropertyPage::OnSetActive();
}
