/*=========================================================================*/
/*                        DeleteCookies.cpp                                */
/*                                                                         */
/*                 Delete Netscape and IE cookies                          */
/*                                                                         */
/*                                                                         */
/*                CookieCop 2 Copyright (c) 2000,2002                      */
/*                       Ziff Davis Media, Inc.                            */
/*                        All rights reserved.							   */
/*																		   */
/*                     Programmed by Mark Sweeney                          */
/*                                                                         */
/*=========================================================================*/
#include "stdafx.h"
#include <Shlobj.h>
#include "cookiecop.h"
#include "DeleteCookies.h"
#include "Registry.h"
#include "CookieListDlg.h"
#include "Hourglass.h"
#include "hlp/helpids.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDeleteCookies dialog


CDeleteCookies::CDeleteCookies(CWnd* pParent /*=NULL*/)
	: CDialog(CDeleteCookies::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDeleteCookies)
	//}}AFX_DATA_INIT
}


void CDeleteCookies::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDeleteCookies)
	DDX_Control(pDX, IDC_DELETE_LIST, m_DeleteList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDeleteCookies, CDialog)
	//{{AFX_MSG_MAP(CDeleteCookies)
	ON_BN_CLICKED(IDC_VIEW, OnView)
	ON_LBN_DBLCLK(IDC_DELETE_LIST, OnDblclkDeleteList)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_LBN_SELCHANGE(IDC_DELETE_LIST, OnSelchangeDeleteList)
	ON_BN_CLICKED(IDHELP, OnHelp)
	ON_BN_CLICKED(IDC_CONFIRMDELETE, OnConfirmdelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DeleteCookies message handlers

BOOL CDeleteCookies::OnInitDialog() 
{
	CDialog::OnInitDialog();

	//1.2
	HANDLE hBitmap = LoadImage( AfxGetInstanceHandle( ), MAKEINTRESOURCE( IDB_RECYCLED ),IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT |LR_LOADMAP3DCOLORS );
	hBitmap = (HBITMAP)GetDlgItem( IDC_RECYCLED )->SendMessage( STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(HBITMAP)hBitmap );  
	if( hBitmap )
		::DeleteObject( hBitmap );
	
	CheckDlgButton( IDC_CONFIRMDELETE, m_theApp->m_bConfirmDelete );

	m_bParsingNetscape = FALSE;

	if( m_theApp->m_bScanFolder_IE == FALSE && m_theApp->m_bScanFolder_Nav == FALSE )
	{
		EndDialog( FALSE );
		return 0;
	}

	if( m_theApp->m_bScanFolder_IE )
		ScanCookiesIE( );
	else
		ScanCookiesNav( );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////
// remove excess elements from the url for scanning -- sets m_sUrl member
void CDeleteCookies::FixUpURL( )
{
	//remove the host portion of the url
	if( isalpha( m_sUrl[0] ) )
	{
		CStringArray sArray;
		if( int nElements =  ParseString( m_sUrl, ".", &sArray ) )
		{
			if( nElements > 2 )
			{
				//build the rest of the url
				m_sUrl ="";
				for( int i = 1; i < nElements; i++ )
				{
					m_sUrl += sArray[i];
					if( i < nElements - 1  )
						m_sUrl += ".";
				}
			}
		}

	}

	//remove any wild cards 
	CString sTmp;
	for( int i = 0; i < m_sUrl.GetLength( ); i++ )
		if( m_sUrl[i] != '*' && m_sUrl[i] != '?' )
			sTmp += m_sUrl[i];

	m_sUrl = sTmp;			 

}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::ScanCookiesIE( )
{
	CString s;
	
	m_hIcon = LoadIcon( AfxGetInstanceHandle(),MAKEINTRESOURCE( IDI_EXPLORER ) );
	HICON hIcon = (HICON)SendDlgItemMessage( IDC_BROWSER_BMP, STM_SETIMAGE, IMAGE_ICON, (LPARAM)(HBITMAP)m_hIcon );
	if( hIcon )
		::DestroyIcon( hIcon );

	if( m_theApp->m_sCookieFile_IE.IsEmpty( ) || ( IsValidDir( m_theApp->m_sCookieFile_IE ) == FALSE ) )
	{
		ShowError( IDS_BAD_COOKIE_DIR_IE, MB_OK );
		EndDialog( FALSE );
		return;
	}

	SetDlgItemText( IDC_DELETE_COOKIE_FILES_TEXT, m_theApp->m_sCookieFile_IE );

	//enum all .txt files in the cookie dir
	WIN32_FIND_DATA finddata;
	HANDLE hFile,hCookieFile;
	char szFile[MAX_PATH];
	char szDir[MAX_PATH];
	char szTmp[4096];	//the rfc states a limit of 4K chars for cookies
	DWORD dwRead;

    //send an empty url to scan for all entries in reject cookie list
    BOOL bScanAllCookies = m_sUrl.IsEmpty( );

    if( !bScanAllCookies )
    {
        FixUpURL( ); 
        m_sSaveUrl = m_sUrl;
        m_sUrl.MakeLower( );

        //remove any leading periods -- IE 5.x
        if( m_sUrl[0] == '.' )
            m_sUrl = m_sUrl.Mid( 1 );
    }

    
	strcpy( szDir, m_theApp->m_sCookieFile_IE );
	strcat( szDir, "\\*.txt"  );	

	hFile = FindFirstFile( szDir, &finddata );
	if( hFile != INVALID_HANDLE_VALUE )
	{
        CHourglass wait( this );
		while( TRUE )
		{	
			int i = 0;

            wsprintf( szFile, "%s\\%s", m_theApp->m_sCookieFile_IE, finddata.cFileName );

			//open and read the file
			hCookieFile = CreateFile( szFile, GENERIC_READ,
				        		  FILE_SHARE_READ, NULL, OPEN_EXISTING, 
						          FILE_ATTRIBUTE_NORMAL, NULL );
			if( hCookieFile != INVALID_HANDLE_VALUE )
			{
				memset( szTmp,0,sizeof(szTmp) );
				ReadFile( hCookieFile , szTmp, sizeof(szTmp)-1,&dwRead,NULL );
				CloseHandle( hCookieFile ); 
				strlwr( szTmp );

                do 
                {
                    if( bScanAllCookies )
                    {
                        if( i >= m_theApp->m_RejectList.GetSize( ) )
                            break;
                        m_sUrl = m_theApp->m_RejectList.GetAt( i++ );
	                   
                        FixUpURL( ); 
                        m_sSaveUrl = m_sUrl;
                        m_sUrl.MakeLower( );

	                    //remove any leading periods -- IE 5.x
	                    if( m_sUrl[0] == '.' )
		                    m_sUrl = m_sUrl.Mid( 1 );

				    }

                    if( strstr( szTmp, m_sUrl ) )
					    m_DeleteList.AddString( szFile );		
                
                }
                while( bScanAllCookies == TRUE );
		
			}	
			if( !FindNextFile( hFile, &finddata ) )
				break;
		}

		FindClose( hFile );
	}

    if( bScanAllCookies == TRUE )
        m_sUrl = "cookies in the Reject list";

	if( m_DeleteList.GetCount() == 0 )
	{
		s.Format( "CookieCop could not find any Cookie files containing references to %s.",  m_sUrl );//m_sSaveUrl );
		SetDlgItemText( IDC_DELETE_MSG, s );
		GetDlgItem( IDC_DELETE_TEXT )->ShowWindow( SW_HIDE );
	} else {
		s.Format( "CookieCop found these Cookie files containing references to %s.",  m_sUrl );//m_sSaveUrl );
		SetDlgItemText( IDC_DELETE_MSG, s );
	}

	if( bScanAllCookies )
        m_sUrl.Empty( );

    EnableControls( );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::ScanCookiesNav( )
{
	
	m_bParsingNetscape = TRUE;
	m_DeleteList.ResetContent( );

    //send an empty url to scan for all entries in reject cookie list
    BOOL bScanAllCookies = m_sUrl.IsEmpty( );
   	
    m_sUrl = m_sSaveUrl;

	SetDlgItemText( IDC_DELETE_COOKIE_FILES_TEXT, m_theApp->m_sCookieFile_Nav );
	
	m_hIcon = LoadIcon( AfxGetInstanceHandle(),MAKEINTRESOURCE( IDI_NETSCAPE ) );
	HICON hIcon = (HICON)SendDlgItemMessage( IDC_BROWSER_BMP, STM_SETIMAGE, IMAGE_ICON, (LPARAM)(HBITMAP)m_hIcon );
	if( hIcon )
		::DestroyIcon( hIcon );


	CStdioFile file;
	CString s,sTmp;
    int i = 0;

	do
    {
        CHourglass wait( this );

        if( bScanAllCookies )
        {
            if( i >= m_theApp->m_RejectList.GetSize( ) )
                break;
            m_sUrl = m_theApp->m_RejectList.GetAt( i++ );
        }
  
        FixUpURL( ); 
       	m_sUrl.MakeLower( );
    
        if( file.Open( m_theApp->m_sCookieFile_Nav, CFile::modeRead  ) )  
	    {
		    while( file.ReadString( s ) )
			    if( s.GetLength() && s.GetAt(0) >= ' ' && s.GetAt(0) != '#' )
			    {
				    sTmp = s;
				    sTmp.MakeLower( );
				    if( strstr( sTmp, m_sUrl ) )
					    m_DeleteList.AddString( s );
			    }

		    file.Close( );
	    } else {
		    ShowError( IDS_BAD_COOKIE_DIR_NAV, MB_OK );
		    EndDialog( FALSE );
	    }

    } while( bScanAllCookies == TRUE );

    if( bScanAllCookies == TRUE )
        m_sUrl = "cookies in the Reject list";

	if( m_DeleteList.GetCount() == 0 )
	{
		s.Format( "CookieCop could not find any references to %s.",  m_sUrl );//m_sSaveUrl );
		SetDlgItemText( IDC_DELETE_MSG, s );
		GetDlgItem( IDC_DELETE_TEXT )->ShowWindow( SW_HIDE );
	} else {
		s.Format( "CookieCop found these references to %s.",  m_sUrl );//m_sSaveUrl );
		SetDlgItemText( IDC_DELETE_MSG, s );
	}

	EnableControls( );

}


/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::OnView() 
{
	int nItem = m_DeleteList.GetCurSel();
	if( nItem >= 0 )
	{
        int nLength = m_DeleteList.GetTextLen( nItem );
        if( nLength > 0 )
        {
            char *buf = new char[nLength+1];
            if( buf )
            {
                m_DeleteList.GetText( nItem, buf );
		        CViewCookieFile*  pView = new CViewCookieFile;
		        pView->m_sFileName = buf;
		        pView->m_bParsingNetscape = m_bParsingNetscape;
		        pView->DoModal( );
		        delete pView;	
                delete [] buf;
            }
        }
	}

}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::OnDblclkDeleteList() 
{
	OnView( );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::OnRemove() 
{
	int nItem = m_DeleteList.GetCurSel();
	if( nItem >= 0 )
	{
		m_DeleteList.DeleteString( nItem );
		if( nItem >= m_DeleteList.GetCount( ) )
			nItem--;
		m_DeleteList.SetCurSel( nItem );
	}
	EnableControls( );
}

/////////////////////////////////////////////////////////////////////////////
//delete the files
void CDeleteCookies::OnOK() 
{
	SHFILEOPSTRUCT sh;

	if( m_bParsingNetscape )
	{
		CStringArray sCookies;
		CStdioFile file;
		CString s,sTmp;
		int i,iCount = m_DeleteList.GetCount( );

		if( file.Open( m_theApp->m_sCookieFile_Nav, CFile::modeRead  | CFile::typeText  ) )  
		{
			while( file.ReadString( s ) )
			{
				BOOL bKeep = TRUE;
				for( i = 0; i < iCount; i++ )
				{
					m_DeleteList.GetText( i, sTmp );
					if( strcmp( s, sTmp ) == 0 )
					{
						bKeep = FALSE;
						break;
					}
						
				}

				if( bKeep )
					sCookies.Add( s );	//keep the line

			}
			file.Close( );

			//send to recycle bin
			char szTmp[MAX_PATH];
			ZeroMemory( szTmp, MAX_PATH );
			strcpy( szTmp, m_theApp->m_sCookieFile_Nav );

			ZeroMemory( &sh, sizeof(sh) );
			sh.hwnd = GetSafeHwnd();
			sh.wFunc = FO_DELETE; 
			sh.fFlags = FOF_ALLOWUNDO;
			if( !m_theApp->m_bConfirmDelete )
				sh.fFlags |= FOF_NOCONFIRMATION;
			sh.pFrom = (LPSTR)(LPCSTR)szTmp;
			if( SHFileOperation( &sh ) == 0 )
			{
				if( sh.fAnyOperationsAborted == FALSE )
				{
					iCount = sCookies.GetSize( );
					if( file.Open( m_theApp->m_sCookieFile_Nav, CFile::modeWrite | CFile::modeCreate | CFile::typeText  ) ) 
					{
						CString s;
						s = 0x0a;
						for( i = 0; i < iCount; i++ )
						{
							file.WriteString( sCookies.GetAt( i ) );			
							file.WriteString( s );			
						}

						file.Close( );
							
					}
				}
			}
		}
	}


	if( !m_bParsingNetscape )
	{
		CByteArray byArray;
		CString s;
		int i,j,iCount = m_DeleteList.GetCount( );

		for( i = 0; i < iCount; i++ )
		{
			m_DeleteList.GetText( i, s );
			for( j = 0; j < s.GetLength(); j++ )
				byArray.Add( s[j] );

			byArray.Add( 0 );
		}
		byArray.Add( 0 );		//terminate with double nulls

		ZeroMemory( &sh, sizeof(sh) );
		sh.hwnd = GetSafeHwnd();
		sh.wFunc = FO_DELETE; 
		sh.fFlags = FOF_ALLOWUNDO;
		if( !m_theApp->m_bConfirmDelete )
			sh.fFlags |= FOF_NOCONFIRMATION;
		sh.pFrom = (LPSTR)(LPCSTR)byArray.GetData( ); 
		SHFileOperation( &sh );
	}

	if( !m_bParsingNetscape && m_theApp->m_bScanFolder_Nav )
		ScanCookiesNav( );
	else
		CDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::EnableControls( )
{
	BOOL bEnable = TRUE;

	if( m_DeleteList.GetCount( ) == 0 )
		bEnable = FALSE;
	GetDlgItem( IDOK )->EnableWindow( bEnable );

	if( !bEnable )
		SetDlgItemText( IDCANCEL, "Close" );
	else
		SetDlgItemText( IDCANCEL, "Cancel" );

	GetDlgItem( IDC_CONFIRMDELETE )->ShowWindow( bEnable ? SW_SHOW:SW_HIDE );

	if( bEnable )
		bEnable =  m_DeleteList.GetCurSel() >= 0 ;
	
	GetDlgItem( IDC_REMOVE )->EnableWindow( bEnable );
	GetDlgItem( IDC_VIEW )->EnableWindow( bEnable );
	

}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::OnSelchangeDeleteList() 
{
	EnableControls( );
}
/////////////////////////////////////////////////////////////////////////////
// CViewCookieFile dialog


CViewCookieFile::CViewCookieFile(CWnd* pParent /*=NULL*/)
	: CDialog(CViewCookieFile::IDD, pParent)
{
	//{{AFX_DATA_INIT(CViewCookieFile)
	//}}AFX_DATA_INIT
}


void CViewCookieFile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewCookieFile)
	DDX_Control(pDX, IDC_COOKIECONTENTS, m_ContentsList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CViewCookieFile, CDialog)
	//{{AFX_MSG_MAP(CViewCookieFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewCookieFile message handlers

BOOL CViewCookieFile::OnInitDialog() 
{
	
	CDialog::OnInitDialog();

	if( m_bParsingNetscape )
	{
		CString s;
		for( int i = 0; i < m_sFileName.GetLength( ); i++ )
		{
			char ch = m_sFileName[i];

			if( ch < ' ' )
			{
				if( s.IsEmpty() == FALSE )
					m_ContentsList.AddString( s );
				s.Empty( );		
			} else {
				s += ch;
			}
		}
	} else {
		CString s;
		CStringArray sContents;
		CStdioFile file;
		
		if( file.Open( m_sFileName, CFile::modeRead  ) )  
		{
			while( file.ReadString( s ) )
			{
				sContents.Add( s );
			}
		
			file.Close( );
		} else {
			sContents.Add( "Error opening file." );
		}
			
		for( int i = 0; i < sContents.GetSize(); i++ )
		{
			m_ContentsList.AddString( sContents.GetAt( i ) );
		}
		
		SetDlgItemText( IDC_FILENAME, m_sFileName );
	}

	m_ContentsList.SetHorizontalExtent( 1000 );
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::OnHelp() 
{
	m_theApp->CWinApp::WinHelp(IDH_delete_cookie_files);
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::OnCancel() 
{
	if( !m_bParsingNetscape && m_theApp->m_bScanFolder_Nav )
		ScanCookiesNav( );
	else
		CDialog::OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CDeleteCookies::OnConfirmdelete() 
{
	m_theApp->m_bConfirmDelete = IsDlgButtonChecked( IDC_CONFIRMDELETE );
	m_theApp->m_pCookieListDlg->SetModified( TRUE );
}
