/*=========================================================================*/
/*                        DropTarget.cpp                                   */
/*                                                                         */
/*     Manages drag & drop into the Cookie and Blocked site lists          */
/*                                                                         */
/*                CookieCop 2 Copyright (c) 2000,2002                      */
/*                       Ziff Davis Media, Inc.                            */
/*                        All rights reserved.							   */
/*																		   */
/*                     Programmed by Mark Sweeney                          */
/*                                                                         */
/*=========================================================================*/
#include "stdafx.h"
#include "CookieCop.h"

/////////////////////////////////////////////////////////////////////////////
// COleDropWndTarget

COleDropWndTarget::COleDropWndTarget() {}
COleDropWndTarget::~COleDropWndTarget() {}     

//
// OnDragEnter is called by OLE dll's when drag cursor enters
// a window that is REGISTERed with the OLE dll's
//
DROPEFFECT COleDropWndTarget::OnDragEnter(CWnd* pWnd, COleDataObject* 
           pDataObject, DWORD dwKeyState, CPoint point )
{
       UNREFERENCED_PARAMETER( pWnd );
	   UNREFERENCED_PARAMETER( pDataObject );
	   UNREFERENCED_PARAMETER( dwKeyState );
	   UNREFERENCED_PARAMETER( point );
	   
	    return DROPEFFECT_MOVE;    
}

//
// OnDragLeave is called by OLE dll's when drag cursor leaves
// a window that is REGISTERed with the OLE dll's
//
void COleDropWndTarget::OnDragLeave(CWnd* pWnd)
{
    // Call base class implementation
    COleDropTarget::OnDragLeave(pWnd);
}
 
// OnDragOver is called by OLE dll's when cursor is dragged over 
// a window that is REGISTERed with the OLE dll's
//
DROPEFFECT COleDropWndTarget::OnDragOver(CWnd* pWnd, COleDataObject* 
           pDataObject, DWORD dwKeyState, CPoint point )
{     
 
   UNREFERENCED_PARAMETER( pDataObject );
   UNREFERENCED_PARAMETER( dwKeyState );
 	
	CWnd* pWnd2 = pWnd->ChildWindowFromPoint( point );
	if( pWnd2 && ( pWnd2->IsWindowEnabled( ) == FALSE ) )
		    return DROPEFFECT_NONE;

        return DROPEFFECT_COPY;  // move source
}


// OnDrop is called by OLE dll's when item is dropped in a window
// that is REGISTERed with the OLE dll's
//
BOOL COleDropWndTarget::OnDrop(CWnd* pWnd, COleDataObject* pDataObject, 
                 DROPEFFECT dropEffect, CPoint point )
{           
	UNREFERENCED_PARAMETER( point );
	UNREFERENCED_PARAMETER( dropEffect );

	HGLOBAL  hGlobal;
	LPCSTR   pData;                     


    // Get text data from COleDataObject
    hGlobal = pDataObject->GetGlobalData( CF_TEXT );
	if( hGlobal )
	{
		// Get pointer to data
		pData=(LPCSTR)GlobalLock(hGlobal);    
		ASSERT(pData!=NULL); 
		
		//send the URL to the parent window of the control
		CWnd* pTmp;
		pTmp = pWnd->GetParent( );
		if( pTmp )
			pTmp->SendMessage( MSG_DRAGDROP, 0, (LPARAM)pData );
		GlobalUnlock( hGlobal );
	} else {
		ShowError( IDS_NOT_TEXT, MB_OK | MB_ICONSTOP );
	}
    return TRUE;
}

