/*=========================================================================*/
/*                        EditUrlDlg.cpp                                   */
/*                                                                         */
/*                 Dialog for entering cookie and site URLs                */
/*                                                                         */
/*                CookieCop 2 Copyright (c) 2000,2002                      */
/*                       Ziff Davis Media, Inc.                            */
/*                        All rights reserved.							   */
/*																		   */
/*                     Programmed by Mark Sweeney                          */
/*                                                                         */
/*=========================================================================*/
#include "stdafx.h"
#include "cookiecop.h"
#include "EditUrlDlg.h"
#include "DlgPropSheet.h"
#include "hlp/helpids.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditUrlDlg dialog


CEditUrlDlg::CEditUrlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditUrlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditUrlDlg)
	m_sUrl = _T("");
	//}}AFX_DATA_INIT
}


void CEditUrlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditUrlDlg)
	DDX_Text(pDX, IDC_URL, m_sUrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditUrlDlg, CDialog)
	//{{AFX_MSG_MAP(CEditUrlDlg)
	ON_BN_CLICKED(IDC_REJECT, OnReject)
	ON_BN_CLICKED(IDC_ACCEPT, OnAccept)
	ON_BN_CLICKED(IDHELP, OnHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditUrlDlg message handlers

void CEditUrlDlg::SetCookieState( )
{
	int nID;
	HBITMAP hBitmap;

	if( m_bAcceptCookie )
	{
		nID = IDC_ACCEPT;
		hBitmap = (HBITMAP)LoadImage( AfxGetInstanceHandle( ), MAKEINTRESOURCE( m_nAccept ),IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT|LR_LOADMAP3DCOLORS );
		hBitmap = (HBITMAP)SendDlgItemMessage( IDC_COOKIE ,STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(HBITMAP)hBitmap );
	} else {
		hBitmap = (HBITMAP)LoadImage( AfxGetInstanceHandle( ), MAKEINTRESOURCE( m_nReject ),IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT|LR_LOADMAP3DCOLORS );
		hBitmap = (HBITMAP)SendDlgItemMessage( IDC_COOKIE ,STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(HBITMAP)hBitmap );
		nID = IDC_REJECT;
	}

	if( hBitmap )
		::DeleteObject( hBitmap );

	CheckRadioButton( IDC_ACCEPT, IDC_REJECT, nID );	
}


/////////////////////////////////////////////////////////////////////////////
// 
BOOL CEditUrlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if( m_ListType == COOKIE_LIST )
	{
		m_nAccept = IDB_ACCEPT_COOKIES;
		m_nReject = IDB_REJECT_COOKIES;
		SetWindowText( "Edit Cookie Site" );
		SetCookieState( );
	} else {
		m_nAccept = IDB_BLOCKED;
		m_nReject = IDB_BLOCKED_IMAGE;
		SetDlgItemText( IDC_ACCEPT, "Block entire site" );
		SetDlgItemText( IDC_REJECT, "Block images only" );
		SetWindowText( "Edit Blocked Site" );
		SetCookieState( );
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// 
void CEditUrlDlg::OnReject() 
{
	m_bAcceptCookie = FALSE;
	SetCookieState( );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CEditUrlDlg::OnAccept() 
{
	m_bAcceptCookie = TRUE;
	SetCookieState( );
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CEditUrlDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if( wParam == IDOK )
	{
		UpdateData( TRUE );
		if( m_sUrl.GetLength( ) == 0 )
		{
			ShowError( IDS_URL_ERR, MB_OK );
			return TRUE;
		}	
	}	
	return CDialog::OnCommand(wParam, lParam);
}

void CEditUrlDlg::OnHelp() 
{
	if( m_ListType == COOKIE_LIST )
		m_theApp->CWinApp::WinHelp(IDH_edit_cookie_site);
	else
		m_theApp->CWinApp::WinHelp(IDH_edit_blocked_site);
	
}
