#ifndef _GLOBALS_H
#define _GLOBALS_H

class CLog;
class CCookieCopApp;
extern	CCookieCopApp* m_theApp;

//state machine
typedef enum {
	ERROR_STATE,
	PROCESS_HTTP_HEADER,
	PROCESS_HTTP_BODY,
} HTML_STATE;

enum COOKIE_COP_STATE {
	STATE_CONNECTED			= 0x01,
	STATE_COOKIE_RECEIVED	= 0x02,
	STATE_COOKIE_REJECTED	= 0x04,
} ;

enum STARTUP_MODE {
	STARTUP_MANUAL,
	STARTUP_BROWSER,
	STARTUP_WINDOWS,
};

enum COOKIE_COP_STATS
{
	STATS_ACCEPTED,
	STATS_REJECTED,
	STATS_CONNECTIONS,
	STATS_BLOCKED,
	STATS_BYTES_RECEIVED,
	STATS_BYTES_SENT,
	STATS_COOKIES_SENT,
    STATS_REFERRER,
	STATS_MAX,
} ;

typedef enum VIEWER_EVENT
{
	VIEWER_MSG		= 0x01,     //flag to highlight/bold the message
	VIEWER_BROWSER	= 0x02,     //show data received from the browser
	VIEWER_SERVER   = 0x10,     //show data received from the web server
	VIEWER_CC       = 0x20,     //show CookieCop messages
    VIEWER_ONTOP    = 0x40,     //display on top -- pushpin
    VIEWER_DEBUG    = 0x80      //for debug messages (not in release version)
};


#define MSG_DRAGDROP WM_USER + 100	//sent from drop target
#define CR '\r'
#define LF '\n'
#define DEFAULT_PORT 8100	/* default port */	
#define	DEFAULT_BUFSIZE      8192     

//Equates for the LogDlg list control
enum {
	COL_TIME = 0,
	COL_URL,
	COL_EVENT,
	COL_ENDOFLIST
};

typedef enum {
	EVENT_CONNECT               = 0x0001,
	EVENT_ERROR                 = 0x0002,
	EVENT_COOKIE_REJECTED       = 0x0004,
	EVENT_COOKIE_ACCEPTED       = 0x0008,
	EVENT_COOKIE_JS             = 0x0010,
	EVENT_COOKIE_SENT           = 0x0020,
	EVENT_COOKIE_BLOCKED        = 0x0040,
	EVENT_SITE_BLOCKED          = 0x0080,
	EVENT_CONNECT_SSL           = 0x0100,
	EVENT_IMAGE_BLOCKED         = 0x0200,
	EVENT_SESSION_COOKIE        = 0x0400,
	EVENT_COOKIE_JS_ACCEPTED    = 0x0800,
    EVENT_REFERER_REMOVED       = 0x1000,
    EVENT_REFERRER_REMOVED_JS   = 0x2000,
} EVENT_TYPE;
#define NUMBER_OF_EVENTS 7	//note:  EVENT_CONNECT_SSL and EVENT_CONNECT count as one event and
							//       EVENT_COOKIE_REJECTED and EVENT_COOKIE_BLOCKED count as one event
							//       EVENT_COOKIE_ACCEPTED and EVENT_COOKIE_JS_ACCEPTED and EVENT_SESSION_COOKIE count as one event

//for viewer status bar
typedef enum {
	UPDATE_CONNECTIONS = 1,
	UPDATE_BYTES,
} UPDATE_VIEWER;


#define COLOR_RED		0x000080L
#define COLOR_GREEN		0x008000L
#define COLOR_BLUE		0x800000L
#define COLOR_PURPLE	0x800080L

#define COLOR_REJECTED COLOR_RED
#define COLOR_ACCEPTED COLOR_GREEN
#define COLOR_BLOCKED  COLOR_BLUE
#define COLOR_SENT     COLOR_PURPLE					
#define COLOR_DIALOG_EVENT RGB(0x00,0x00,0xff) 		

//TIMERS
#define ICON_TIMER          500
#define STATS_TIMER         501
#define PERFORMANCE_TIMER   502

//INI Files
#define SZ_BLOCKED_SITE_INI		"BlockedSite.Txt"
#define SZ_BLOCKED_IMAGE_INI	"BlockedImage.Txt"
#define SZ_REJECT_INI			"Reject.Txt"
#define SZ_ACCEPT_INI			"Accept.Txt"
#define SZ_COOKIECOP_INI		"CookieCop.Ini"
#define SZ_STATS_FILE			"Stats.dat"

#define SZ_APPNAME				"CookieCop"
#define SZ_COOKIE_IP			"CookieIP"
#define SZ_COOKIE_PORT			"CookiePort"
#define SZ_GATEWAY_IP			"GatewayIP"
#define SZ_GATEWAY_PORT			"GatewayPort"
#define SZ_GATEWAY_ENABLE		"GatewayEnable"
#define SZ_MAX_EVENTS			"MaxEvents"
#define	SZ_JAVASCRIPT			"SearchJavaScript"
#define SZ_DEFAULTACTION		"DefaultCookieAction"
#define SZ_STARTUPMODE			"Startup"
#define SZ_HTML_FILE			"HtmlFile"
#define SZ_EVENTMASK			"EventMask"
#define SZ_COLWIDTH				"Column"
#define SZ_BLOCKIMAGES			"BlockImages"
#define SZ_ONTOP				"DisplayOnTop"
#define	SZ_DISABLECOOKIELIST	"DisableCookieList"
#define	SZ_DISABLEBLOCKEDLIST	"DisableBlockedList"
#define	SZ_DISABLELOG			"DisableLog"
#define SZ_RESET_STATS			"ResetStats"
#define SZ_WARNINGS				"Warnings"
#define SZ_NAV_COOKIE_FILE		"NetscapeCookieFile"
#define SZ_IE_COOKIE_FOLDER		"IECookieFolder"
#define SZ_IE_SCAN_COOKIE_FILE	"ScanIECookies"
#define SZ_NAV_SCAN_COOKIE_FILE "ScanNavCookies"
#define SZ_CONFIRM_DELETE		"ConfirmDelete"	
#define	SZ_BLOCKED_SITE_FILE	"BlockedSiteFile"
#define SZ_BLOCKED_IMAGE_FILE	"BlockedImageFile"
#define SZ_COLOR_BACKGROUND		"Color_Background"
#define SZ_COLOR_HTTP			"Color_HTTP"
#define SZ_COLOR_HTML			"Color_HTML"
#define SZ_COLOR_MESSAGES		"Colors_Messages"
#define SZ_FONTNAME             "FontName"
#define SZ_FONTHEIGHT			"FontHeight"
#define SZ_FONTFAMILY           "FontFamily"
#define SZ_AUTOSCROLL			"AutoScroll"
#define SZ_VIEWERMASK			"ViewerEventMask"
#define SZ_LIMIT_LINES			"LimitLines"
#define SZ_LIMIT_LINES_AMOUNT	"Lines"
#define SZ_CHECK_REFERER        "CheckReferer"
#define SZ_VIEWER_OPEN          "ViewerOpen"
#define SZ_WINPOS_LEFT          "ViewerWinLeft"
#define SZ_WINPOS_TOP           "ViewerWinTop"
#define SZ_WINPOS_BOTTOM        "ViewerWinBottom"
#define SZ_WINPOS_RIGHT         "ViewerWinRight"
#define SZ_DISABLED             "Disabled"
#define SZ_USE_DEFAULT_SIZES    "UseDefaultBufferSizes"
#define SZ_BUFFER_SIZE          "BufferSize"    //socket buffer size for send and recv
#define SZ_DNS_CACHE_SIZE       "DNSCacheSize"
#define SZ_DNS_CACHE_DISABLE    "DNSCacheDisable"
#define SZ_DISABLE_PROXY        "DisableProxy"    
#define SZ_POPUP_CHECK_DISABLED "PopupCheckDisabled"
#define SZ_POPUP_MODE           "PopupMode"
#define SZ_TIMEOUT              "ConnectionTimeOut"
#define SZ_DEFAULT_TIMEOUT      "UseDefaultTimeOut"

#define SZ_PROMPT_POPUPS_FILE   "prompt_popups.js"
#define SZ_PROMPT_POPUPS_JS_FILE "prompt_popupsJS.js"

#define SZ_NOPROMPT_POPUPS_FILE "no_prompt_popups.js"
#define SZ_INTERNET_KEY         "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings"
#define SZ_PROXY_KEY            "ProxyEnable"

static char SZ_IE_REG_SETTINGS[]="Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings";


#define MAX_CACHE 100

//prototypes
struct hostent* GetHostByAddr ( LPCSTR lpszIP ) ;
BOOL WriteHostsFile( LPSTR lpAddr, LPCSTR lpName );
BOOL ParseHostsFile( CWnd* pCtrl, LPCSTR lpCurrent );
int	ShowError( int nID, int nMode, CWnd* pWnd );
int ShowError( int nID, int nMode );
int ShowError( LPCSTR pErr );
void GetWinsockError( LPSTR pErrMsg );
void ShowWinsockError( SOCKET s = INVALID_SOCKET /*s = INVALID_SOCKET */, LONG nSessionID = 0 /*SessionID = 0*/, LPSTR pErrMsg = 0 /*pErrMsg = 0*/ );
void ValidateHeader( CString* p );
void FormatHeader( CStringArray* headers, CString *p );
//int Send_Data( CAsyncSocket* s, CByteArray*, int nStats );
BOOL CheckHeader( CByteArray* pArray );
BOOL MatchPattern( LPCSTR pString, LPCSTR pPattern );
void FormatUrl( CString *pUrl );
LPSTR FormatNumber( DWORD );
BOOL ExtractUrl( CString *pUrl, BOOL bUseWildCards );
void SaveEventMask( );
int ParseString( LPCSTR pString, char *pDelimiters, CStringArray* pElements );
void QualifyPathName( CString *pFile, LPCSTR pIni );
BOOL IsExplorer( );
BOOL IsValidDir( LPCTSTR pPath );
void CheckCookies( CStringArray* pHeader, CString sHost );
BOOL CheckAcceptList( CString sHost, CString* pPattern );
BOOL CheckRejectList( CString sHost, CString* pPattern );
void WritePrivateProfile( LPCSTR pSection, int nValue );
void WritePrivateProfile( LPCSTR pSection, LPCSTR pValue );
void GetPrivateProfile( LPCSTR pSection, int* pValue, int nDefault = 0 /*int nDefault = 0*/ );
void GetPrivateProfile( LPCSTR pSection, CString* pString, LPCSTR pDefault = ""  /*LPCSTR pDefault = "" */);
void LoadViewerPosition( CRect *pRect );
void SaveViewerPosition( CRect *pRect );
void VerifyFile( LPCSTR pDesc, LPCSTR pFile);
void LoadDataFiles( );
BOOL ReadFileData( CByteArray* pArray, LPCSTR pFile );
void ResetFileErrorWarnings( );
void ReadBlockedFile( );
void ReadRejectFile( );
void ReadAcceptFile( );
void WriteBlockedFile( );
void WriteRejectFile( );
void WriteAcceptFile( );
void ReadCookieCopFile( );
void WriteCookieCopFile( );
void ReadStatsFile( );
void WriteStatsFile( );

void _cdecl DebugOut_CompiledOutOfReleaseBuild( TCHAR *format,... );

#ifdef _DEBUG
	#define DebugOut DebugOut_CompiledOutOfReleaseBuild
#else
	#define DebugOut 1 ? (void)0 : DebugOut_CompiledOutOfReleaseBuild
#endif 


//From the April 1000 Platform SDK
//Use for Fast User Switching under XP
#define WM_WTSSESSION_CHANGE            0x02B1

#define WTS_CONSOLE_CONNECT                0x1
#define WTS_CONSOLE_DISCONNECT             0x2
#define WTS_REMOTE_CONNECT                 0x3
#define WTS_REMOTE_DISCONNECT              0x4
#define WTS_SESSION_LOGON                  0x5
#define WTS_SESSION_LOGOFF                 0x6
#define WTS_SESSION_LOCK                   0x7
#define WTS_SESSION_UNLOCK                 0x8
#define NOTIFY_FOR_THIS_SESSION     0

#endif //_GLOBALS_H

