/*=========================================================================*/
/*                          PopupDlg.cpp                                   */
/*                                                                         */
/*                  The is the Navagation Tab                              */
/*                                                                         */
/*                CookieCop 2 Copyright (c) 2000,2002                      */
/*                       Ziff Davis Media, Inc.                            */
/*                        All rights reserved.							   */
/*																		   */
/*                     Programmed by Mark Sweeney                          */
/*                                                                         */
/*=========================================================================*/

#include "stdafx.h"
#include "cookiecop.h"
#include "PopupDlg.h"
#include "CookieCopDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPopupDlg property page

IMPLEMENT_DYNCREATE(CPopupDlg, CPropertyPage)

CPopupDlg::CPopupDlg() : CPropertyPage(CPopupDlg::IDD)
{
	//{{AFX_DATA_INIT(CPopupDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CPopupDlg::~CPopupDlg()
{
}

void CPopupDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPopupDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPopupDlg, CPropertyPage)
	//{{AFX_MSG_MAP(CPopupDlg)
	ON_BN_CLICKED(IDC_CHECK_REFERER, OnCheckReferer)
	ON_BN_CLICKED(IDC_NO_PROMPT_POPUPS, OnPromptPopups)
	ON_BN_CLICKED(IDC_DISABLE_POPUP_CHECK, OnDisablePopupCheck)
    ON_BN_CLICKED(IDC_PROMPT_POPUPS, OnPromptPopups)
	ON_BN_CLICKED(IDC_SHOW_VIEWER, OnShowViewer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPopupDlg message handlers

BOOL CPopupDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();


	HANDLE hBitmap = LoadImage( AfxGetInstanceHandle( ), MAKEINTRESOURCE(IDB_POPUP),IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT|LR_LOADMAP3DCOLORS);
    hBitmap = (HBITMAP)SendDlgItemMessage( IDC_POPUP_BMP,STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(HBITMAP)hBitmap );

	if( hBitmap )
		::DeleteObject( hBitmap );

	hBitmap = LoadImage( AfxGetInstanceHandle( ), MAKEINTRESOURCE(IDB_REFERRER),IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT|LR_LOADMAP3DCOLORS);
    hBitmap = (HBITMAP)SendDlgItemMessage( IDC_REFERRER_BMP, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(HBITMAP)hBitmap );
    if( hBitmap )
		::DeleteObject( hBitmap );

    if( m_theApp->m_nPopupMode )
        CheckDlgButton( IDC_NO_PROMPT_POPUPS, TRUE );
    else
        CheckDlgButton( IDC_PROMPT_POPUPS, TRUE );

    CheckDlgButton( IDC_DISABLE_POPUP_CHECK, m_theApp->m_bPopupCheckDisabled ); 
    CheckDlgButton( IDC_CHECK_REFERER, m_theApp->m_bCheckReferer ); 	
    OnDisablePopupCheck( );
    VerifyPopupFiles( );
    SetModified( FALSE ); 
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


/////////////////////////////////////////////////////////////////////////////
// 
void CPopupDlg::VerifyPopupFiles( )
{
	CString sFile;

    if( m_theApp->m_nPopupMode )
    {
        m_theApp->m_sPopupFile = SZ_NOPROMPT_POPUPS_FILE;
    } else {
        m_theApp->m_sPopupFile = SZ_PROMPT_POPUPS_FILE;
    }
    
	//qualify the path name if necessary
	if( m_theApp->m_sPopupFile.IsEmpty( ) == FALSE )
	{
		if( strchr( m_theApp->m_sPopupFile,'\\' ) == 0 )
		{
			QualifyPathName( &sFile, m_theApp->m_sPopupFile );
			m_theApp->m_sPopupFile = sFile;
		}
	}
    VerifyFile( "Popup", m_theApp->m_sPopupFile );


	//check both files
    m_theApp->m_sPopupFileJS = SZ_PROMPT_POPUPS_JS_FILE;        
	if( m_theApp->m_sPopupFileJS .IsEmpty( ) == FALSE )
	{
		if( strchr( m_theApp->m_sPopupFileJS ,'\\' ) == 0 )
		{
			QualifyPathName( &sFile, m_theApp->m_sPopupFileJS );
			m_theApp->m_sPopupFileJS  = sFile;
		}
	}
    VerifyFile( "Popup", m_theApp->m_sPopupFileJS );



}


/////////////////////////////////////////////////////////////////////////////
// 
void CPopupDlg::OnCheckReferer() 
{
    SetModified( TRUE );
    m_theApp->m_bCheckReferer = IsDlgButtonChecked( IDC_CHECK_REFERER );
}


/////////////////////////////////////////////////////////////////////////////
// 
void CPopupDlg::OnPromptPopups() 
{
    SetModified( TRUE );

    //0 for prompts, 1 for no prompts
    m_theApp->m_nPopupMode = IsDlgButtonChecked( IDC_NO_PROMPT_POPUPS );
    VerifyPopupFiles( );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CPopupDlg::OnDisablePopupCheck() 
{
    SetModified( TRUE );
    m_theApp->m_bPopupCheckDisabled = IsDlgButtonChecked( IDC_DISABLE_POPUP_CHECK );
    GetDlgItem( IDC_NO_PROMPT_POPUPS )->EnableWindow( m_theApp->m_bPopupCheckDisabled == FALSE );
    GetDlgItem( IDC_PROMPT_POPUPS )->EnableWindow( m_theApp->m_bPopupCheckDisabled == FALSE );
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CPopupDlg::OnApply() 
{
    WriteCookieCopFile( );

    //reload the data files - popups and blocked sites/images
    LoadDataFiles( );

    SetModified( FALSE );	
	return CPropertyPage::OnApply();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CPopupDlg::OnShowViewer() 
{
    m_theApp->m_pCookieDlg->OnShowViewer( );  	
}
