#if !defined(AFX_PROXY_H__DA102A6D_70F4_11D3_ABBA_0000E8DE2EC4__INCLUDED_)
#define AFX_PROXY_H__DA102A6D_70F4_11D3_ABBA_0000E8DE2EC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PROXY.h : header file
//
enum MIMETYPES
{
    TYPE_UNKNOWN    = 0x00,
    TYPE_HTML       = 0x01,
    TYPE_JAVASCRIPT = 0x02,
    TYPE_IMAGE      = 0x04,
    TYPE_TEXT       = 8//TYPE_JAVASCRIPT | TYPE_HTML  //either HTML or JavaScript
};


/////////////////////////////////////////////////////////////////////////////
// CProxy command target

class CProxy 
{

	
// Attributes
public:
	

// Operations
public:
	
	CProxy();
	virtual ~CProxy();
	void StartSession();


// Overrides
public:
	// Generated message map functions
	//{{AFX_MSG(CProxy)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
protected:
public:	
	CByteArray		m_HostBuffer;
	CByteArray		m_BrowserBuf;
	CStringArray	m_sBrowserHeaders;
    CStringArray    m_sHostHeaders;    
    CString			m_sCommand;
	BOOL			m_bSSL;
	CString			m_sRequestLine;
	CString			m_sUrl;
	CString			m_sVersion;
	CString			m_sHostAddr;
	CString			m_sPath;
	int				m_nHostPort;
	CString			m_sDomain;
	
	HTML_STATE		m_HostState;
    HTML_STATE      m_BrowserState;
    WORD            m_wMimeType;

	SOCKET			m_hHostSocket;
	SOCKET			m_hBrowserSocket;	
	LONG			m_nSessionID;
	CStringArray	m_sTagArray;
    CUIntArray      m_nTagArrayOffset;
    BOOL            m_bCheckJSReferrer;
    BOOL            m_bInAcceptList;
    BOOL            m_bInRejectList;
    CString         m_sPattern; //entry used in the cookie accept or reject list

    int             m_nResponseCode;
    int             m_nContentLength;
    int             m_nHostBytes ;
    BOOL            m_bChunked;
    CByteArray      m_ChunkBuffer;
    CStringArray    m_sChunkedHeaders;
    
    int             m_nSendBufSize;
    int             m_nRecvBufSize;
    CString         m_sMimeType;    //host's response mime type

    CString         m_sLastDomain ;
    int             m_nLastPort;

private:
	BOOL GetRequest( );
	void AddToBrowserBuffer( LPBYTE p, int nLength );
	void AddToHostBuffer( LPBYTE p, int nLength );
	BOOL ConnectToHost( );
	SOCKET Connect( LPCSTR pHost, int nPort );
	void CloseSockets( );
	void DoProxy( char * );
	void ProcessHostData( );
	BOOL CheckJavaScriptCookies( CByteArray *p );
	void CheckMetaCookies( CByteArray *p );
	void AddEvent( EVENT_TYPE event, LPCSTR pURL, LPCSTR pCommand, LPCSTR pPattern );
	void CheckCookies( CStringArray* pHeader, CString sHost );
	int Send_Data( SOCKET s, CByteArray* pData, int nStats );
	void ParseRequest( CString *req );
	BOOL IsSiteBlocked( );
	void Viewer( VIEWER_EVENT event, LPCSTR pEvent, LPCSTR buf, int nBytes );
	BOOL ConvertToSessionOnly( LPSTR p, LPSTR pLowerCase = NULL /*LPSTR pLowerCase = NULL*/, BOOL bInHeader = FALSE /*BOOL bInHeader = FALSE*/ );
	BOOL IsJavaScript( LPCSTR pBuf, UINT nOffset, BOOL *pBody = NULL /*BOOL *pBody = NULL */ );
	BOOL IsMetaTag( UINT nLength );
    BOOL ProcessBrowserData( );

	void GetTags( LPCSTR pBuf, int nLength );
	int  FindEndScript( LPCSTR pBuf, int nLength, int i );
	BOOL MakeTag( LPCSTR pBuf, int nLength, int iStart, CString& sTag );
	BOOL CreateHeader( CByteArray *pByteArray, CStringArray *pHeaders, BOOL bIsResponse = FALSE /*BOOL bIsResponse = FALSE*/);

	void UpdateViewerStatusBar( WPARAM wParam = 0, LPARAM lParam = 0);
    BOOL CheckReferer( );
    void CheckJavaScriptReferrer( CByteArray *p );
    BOOL DisablePopups( CByteArray *p, LPCSTR buf );
    void RemovePopupFromHeader( CStringArray* pHeaders );
    void RemoveOpenFromHTML( LPSTR p, CByteArray* pArray );
    void SendHostBuffer( );
    void FixContentLength( CStringArray* pHostHeaders, CByteArray* pHostBuffer );
    BOOL CreateHostHeader( );
    void InitHostStates( );
    int InBlockedList( LPCSTR pDomain, CStringArray* pBlockedList );
    void SendHostHeader( );
    BOOL ProcessChunkedData( );
    int  GetChunk( );
    BOOL IsIdempotent( LPCSTR pHeader );



};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.


#endif // !defined(AFX_PROXY_H__DA102A6D_70F4_11D3_ABBA_0000E8DE2EC4__INCLUDED_)
