/////////////////////////////////////////////////////////////////////////////
// CRegistry

class CRegistry
{
public:
    CRegistry();
    ~CRegistry();

	
// Attributes
public:
	operator HKEY() const;
	HKEY m_hKey;

// Operations
public:
	LONG SetValue(DWORD dwValue, LPCTSTR lpszValueName);

	LONG QueryValue( LPTSTR lpValueName, LPDWORD dwType, PBYTE lpData, LPDWORD lpcbData );
	LONG QueryValue(DWORD& dwValue, LPCTSTR lpszValueName);
	LONG QueryValue(LPTSTR szValue, LPCTSTR lpszValueName, DWORD* pdwCount);
	LONG SetValue(LPCTSTR lpszValue, LPCTSTR lpszValueName = NULL);
	LONG QueryValueLength( DWORD& dwValue, LPCSTR lpszKeyName );
	LONG QueryValue( LPBYTE pByte, int nBytes, LPCTSTR lpszValueName );
	LONG SetValueBinary(LPBYTE pByte, DWORD dwLen, LPCTSTR lpszValueName);


	LONG SetKeyValue(LPCTSTR lpszKeyName, LPCTSTR lpszValue, LPCTSTR lpszValueName = NULL);
	static LONG WINAPI SetValue(HKEY hKeyParent, LPCTSTR lpszKeyName,
								LPCTSTR lpszValue, LPCTSTR lpszValueName = NULL);

	LONG Create(HKEY hKeyParent, LPCTSTR lpszKeyName,
				LPTSTR lpszClass = REG_NONE, DWORD dwOptions = REG_OPTION_NON_VOLATILE,
				REGSAM samDesired = KEY_ALL_ACCESS,
				LPSECURITY_ATTRIBUTES lpSecAttr = NULL,
				LPDWORD lpdwDisposition = NULL);

	LONG Open(HKEY hKeyParent, LPCTSTR lpszKeyName,	REGSAM samDesired = KEY_ALL_ACCESS);
	LONG Open(LPCTSTR lpszKeyName,	REGSAM samDesired = KEY_ALL_ACCESS);
	LONG Close();
	HKEY Detach();
	void Attach(HKEY hKey);
	LONG DeleteSubKey(LPCTSTR lpszSubKey);
	LONG RecurseDeleteKey(LPCTSTR lpszKey);
	LONG DeleteValue(LPCTSTR lpszValue);
	LONG EnumKey( DWORD, LPTSTR lpszBuf, DWORD dwBuf );
};

inline CRegistry::CRegistry() {m_hKey = NULL;}
inline CRegistry::~CRegistry() { Close();}
inline CRegistry::operator HKEY() const { return m_hKey; }

inline HKEY CRegistry::Detach()
{
	HKEY hKey = m_hKey;
	m_hKey = NULL;
	return hKey;
}

inline void CRegistry::Attach( HKEY hKey )
{
	_ASSERTE(m_hKey == NULL);
	m_hKey = hKey;
}

inline LONG CRegistry::DeleteSubKey(LPCTSTR lpszSubKey)
{
	_ASSERTE(m_hKey != NULL);
	return RegDeleteKey(m_hKey, lpszSubKey);
}

inline LONG CRegistry::DeleteValue(LPCTSTR lpszValue)
{
	_ASSERTE(m_hKey != NULL);
	return RegDeleteValue(m_hKey, (LPTSTR)lpszValue);
}
