/*=========================================================================*/
/*                           Stats.cpp                                     */
/*                                                                         */
/*                                                                         */
/*                CookieCop 2 Copyright (c) 2000,2002                      */
/*                       Ziff Davis Media, Inc.                            */
/*                        All rights reserved.							   */
/*																		   */
/*                     Programmed by Mark Sweeney                          */
/*                                                                         */
/*=========================================================================*/
#include "stdafx.h"
#include "cookiecop.h"
#include "Stats.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CStats property page

IMPLEMENT_DYNCREATE(CStats, CPropertyPage)

CStats::CStats() : CPropertyPage(CStats::IDD)
{
	//{{AFX_DATA_INIT(CStats)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CStats::~CStats()
{
}

void CStats::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStats)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStats, CPropertyPage)
	//{{AFX_MSG_MAP(CStats)
	ON_BN_CLICKED(IDC_RESET_STATS, OnResetStats)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SAVE_STATS, OnSaveStats)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStats message handlers

BOOL CStats::PreTranslateMessage(MSG* pMsg) 
{
	m_ToolTip.RelayEvent( pMsg );	
	return CPropertyPage::PreTranslateMessage(pMsg);
}

/////////////////////////////////////////////////////////////////////////////
// 
void CStats::UpdateStats( )
{
	
	//1.3 -- added cookies sent
	SetDlgItemText( IDC_COOKIES_SENT, FormatNumber( m_theApp->m_dwStats[STATS_COOKIES_SENT] ) );
	SetDlgItemText( IDC_COOKIES_ACCEPTED, FormatNumber( m_theApp->m_dwStats[STATS_ACCEPTED] ) );
	SetDlgItemText( IDC_COOKIES_REJECTED, FormatNumber( m_theApp->m_dwStats[STATS_REJECTED] ) );
	SetDlgItemText( IDC_BYTES_RECEIVED, FormatNumber( m_theApp->m_dwStats[STATS_BYTES_RECEIVED] ) );
	SetDlgItemText( IDC_BYTES_SENT, FormatNumber( m_theApp->m_dwStats[STATS_BYTES_SENT] ) );
	SetDlgItemText( IDC_SITES_CONNECTED, FormatNumber( m_theApp->m_dwStats[STATS_CONNECTIONS] ) );
	SetDlgItemText( IDC_SITES_BLOCKED, FormatNumber( m_theApp->m_dwStats[STATS_BLOCKED] ) );
    SetDlgItemText( IDC_REFERER_REMOVED, FormatNumber( m_theApp->m_dwStats[STATS_REFERRER] ) );
    
}

/////////////////////////////////////////////////////////////////////////////
// 
void CStats::OnResetStats() 
{
	m_theApp->ResetStats( );
	UpdateStats( );
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CStats::OnSetActive() 
{
	UpdateStats( );
	SetTimer( STATS_TIMER, 500, NULL );
	return CPropertyPage::OnSetActive();
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CStats::OnKillActive() 
{
	KillTimer( STATS_TIMER );	
	return CPropertyPage::OnKillActive();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CStats::OnTimer(UINT nIDEvent) 
{
	UNREFERENCED_PARAMETER( nIDEvent );
	UpdateStats( );
}


/////////////////////////////////////////////////////////////////////////////
// 
void CStats::OnSaveStats() 
{
	SetModified( TRUE );	
}

/////////////////////////////////////////////////////////////////////////////
// 
void CStats::UpdateControls( )
{
	CheckDlgButton( IDC_SAVE_STATS, m_theApp->m_bSaveStats );
}

/////////////////////////////////////////////////////////////////////////////
// 
void CStats::SetBitmap( WORD wControl, WORD wBitmapID )
{

	HANDLE hBitmap = LoadImage( AfxGetInstanceHandle( ), MAKEINTRESOURCE( wBitmapID ),IMAGE_BITMAP,0,0,LR_LOADTRANSPARENT|LR_LOADMAP3DCOLORS );
	hBitmap = (HBITMAP)GetDlgItem( wControl )->SendMessage( STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)(HBITMAP)hBitmap );
	if( hBitmap )
		::DeleteObject( hBitmap );	//delete previous bitmap

}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CStats::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_ToolTip.Create( this );
	m_ToolTip.AddTool( GetDlgItem( IDC_SAVE_STATS  ), IDS_SAVE_STATS  );
	m_ToolTip.AddTool( GetDlgItem( IDC_RESET_STATS ), IDS_RESET_STATS );
	
	SetBitmap( IDC_COOKIES_SENT_BMP, IDB_COOKIE_UPLOAD );
	SetBitmap( IDC_STATS_ACCEPTED_BMP, IDB_ACCEPT_COOKIES );
	SetBitmap( IDC_STATS_REJ_BMP, IDB_REJECT_COOKIES );
	SetBitmap( IDC_STATS_RECV_BMP,IDB_ARROW_RIGHT );
	SetBitmap( IDC_STATS_TRANS_BMP, IDB_ARROW_LEFT );
	SetBitmap( IDC_SITES_CONNECTED_BMP, IDB_URL );
	SetBitmap( IDC_SITES_BLOCKED_BMP,IDB_BLOCKED );

	UpdateControls( );
	SetModified( FALSE );
			
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


/////////////////////////////////////////////////////////////////////////////
// 
void CStats::OnReset() 
{
	m_theApp->ReadDataFiles();	
	UpdateControls( );
	SetModified( FALSE );	
	CPropertyPage::OnReset();
}

/////////////////////////////////////////////////////////////////////////////
// 
BOOL CStats::OnApply() 
{
	m_theApp->m_bSaveStats = IsDlgButtonChecked( IDC_SAVE_STATS );	
	WriteCookieCopFile( );
	SetModified( FALSE );
	return CPropertyPage::OnApply();
}

/////////////////////////////////////////////////////////////////////////////
// 
void CStats::EnableTimer( BOOL bEnable ) 
{
    if( bEnable )
        SetTimer( STATS_TIMER, 500, NULL );
    else
        KillTimer( STATS_TIMER );		
}
